%%
%% appevalfactory.tex
%% $Id: appevalfactory.tex,v 1.8 2003-03-07 10:01:20 baurma Exp $
%%

\section{JNukeEvalFactory}

\label{app:evalfactory}

All implemented location evaluation functions used in bytecode
suitable to be used for instrumentation rules have been combined
into a collection object called \texttt{JNukeEvalFactory}. Figure
\ref{fig:evalfactoryfunclist} shows a list of all implemented 
functions. To obtain a particular implementation of an location evaluation 
function, the factory method \texttt{JNukeEvalFactory\_get} may
be used. Individual functions are selected by using an integer
constant with a descriptive name.

\texttt{JNukeEvalFactory} is a static object and therefore does not
require a constructor.

\begin{figure}[ht!]
\begin{center}
\begin{tabular}{|ll|}
\hline
Name                       & Parameter    \\
\hline
eval\_everywhere           & ---          \\
eval\_nowhere              & ---          \\
eval\_atInstruction        & opcode       \\
eval\_atReturnInstruction  & ---          \\
eval\_atInvokeInstruction  & ---          \\
eval\_atOffset             & offset       \\
eval\_atBeginOfMethod      & ---          \\
eval\_atEndOfMethod        & ---          \\
eval\_atNewRunnable        & ---          \\
eval\_atThreadInterrupt    & ---          \\
eval\_atObjectWait         & ---          \\
eval\_atObjectNotify       & ---          \\
eval\_matchesThreadChange  & ThreadChange \\
eval\_inThreadChangeVector & vector       \\
eval\_inMethodNamed        & MethodName   \\
eval\_inRunMethod          & ---          \\
eval\_atBeginOfMainMethod  & ---          \\
eval\_atBeginOfRunMethod   & ---          \\
eval\_atReturnInRunMethod  & ---          \\
eval\_atClassForName       & ---          \\
\hline
\end{tabular}
\end{center}
\caption{Predefined factory location evaluation methods}
\label{fig:evalfactoryfunclist}
\end{figure}


%% ------------------------------------------------------------------

\subsection{JNukeEvalFactory\_get}

\code{
ir\_evalfunc \\
JNukeEvalFactory\_get ( \\
\tab	evalFactoryMethod idx \\
)
}


\subsubsection{Description}

Return a pointer to a particular implementation from the collection of 
implemented location evaluation function.

\subsubsection{Parameters}

\begin{description}
\ttitem{idx}
	Symbolic constant to access the location evaluation function.
\end{description}

\subsubsection{Return value}

A pointer to the factory method or \texttt{NULL} if the index 
was invalid. The returned pointer will reference a function that
has the following signature:

\code{
int \\
ir\_evalfunc ( \\
\tab	JNukeObj * instrument, \\
\tab	JNukeObj * data \\
)
}
